% Matlab Script By Nasser Abbasi, MAE200B, UCI.
% Animation for HW5, prob #1 wave equation on square memberance

clear all; close all;

a = 2; b = 2; c = 4;
x = 0:.05:a; 
y = 0:.05:b;

nPoints = length(x);
[X,Y]   = meshgrid(x,y);
nTerms  = 30;     %How many terms to add in Fourier series
m       = 1;
tfinal  = 20;    % how long to run animation
dt      = 0.005;  %make dt larger for faster animation

for t = 1:dt:tfinal
    U = zeros(nPoints);
    for n = 1:nTerms
        lambda   = (n*pi/a)^2 + (m*pi/b)^2;
        timeTerm = cos( sqrt(lambda) *c*t);
        mu_n     = n*pi/a;        
        A_nm     = -16*(-1+(-1)^n)/(n*pi)^3;
        U        = U + A_nm .* timeTerm .* sin(mu_n*X) .* sin(m*pi/b*Y);
    end    
    clf;
    surf(U);   colormap(jet);
    axis([0 Inf 0 Inf -.8 .8]);
    title(sprintf('time=%1.3f sec',t))
    xlabel('x'); ylabel('y');
    drawnow;
end
